import time
from picamera import PiCamera
import gpio
import config

def get_setting(key):
    return config.get_setting('camera', key).strip('"')

def get_setting_int(key):
    return int(get_setting(key))

def get_setting_bool(key):
    return get_setting(key) == 'True'

def take_pic(image, preview = False, delay = 0):
    if CAMERA_TAKE_PIC_PRE_POST_SHORT_BEEP:
        gpio.beeper_short_beep()
        
    preview and camera.start_preview()
    delay and time.sleep(delay)
    camera.capture(image)
    preview and camera.stop_preview()
    
    if CAMERA_TAKE_PIC_PRE_POST_SHORT_BEEP:
        gpio.beeper_short_beep()
    
def start_camera_preview():
    camera.start_preview()
    
def end_camera_preview():
    camera.stop_preview()
    

CAMERA_TAKE_PIC_PRE_POST_SHORT_BEEP = get_setting_bool('CAMERA_TAKE_PIC_PRE_POST_SHORT_BEEP')
ROTATION = get_setting_int('ROTATION')
RESOLUTION_WIDTH = get_setting_int('RESOLUTION_WIDTH')
RESOLUTION_HEIGHT = get_setting_int('RESOLUTION_HEIGHT')

camera = PiCamera()
camera.rotation = ROTATION
camera.resolution = (RESOLUTION_WIDTH, RESOLUTION_HEIGHT)
