import serial
import gpio

def init():
    return serial.Serial('/dev/ttyS0', baudrate = 9600, parity=serial.PARITY_NONE,\
      stopbits=serial.STOPBITS_ONE, bytesize=serial.EIGHTBITS, timeout=1)

def convert_result(result, final):
    # Converts the result (list of integers) to a format needed by the serial receiving device.
    # Returns bytes
    gpio.led_processing_blink()
    header = 'ZZ' if final else 'YY'
    t = result.copy()
    t.insert(0, header)
    t.append('SS')
    t = [str(block).zfill(2) for block in t]
    t = ','.join(t)
    
    return bytes(t, 'utf-8')